var pXml = new XMLHttpRequest();
var audioURL;
var lastTheme;
var currentTheme;
var oldCustomStations = 0;
var aS = "3";
var currentVolume = "100";
var isPlaying = 0;
var c1name;
var c1url;
var c2name;
var c2url;
var c3name;
var c3url;
System.Gadget.Flyout.file = "radioFlyout.html";
System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = SettingsClosed;

window.onload = function()
{
	// check for currentTheme
	currentTheme = new String(System.Gadget.Settings.read("themePicker"));
	if (currentTheme == "")
	{
		currentTheme = "Common_Presets";
		System.Gadget.Settings.write("themePicker", "Common_Presets");
	}
	else
	{
		updateTheme();
	}
	// stored to detect changes in the theme later on
	lastTheme = currentTheme;

	tidyupCustom();

	// presetCheck();

	// now that we know the theme and the current volume, update the graphics and volume
	updateTheme();
	//presetCheck();
	presetAlt();

	currentVolume = new String(System.Gadget.Settings.read("UKRPVolume"));
	if (currentVolume == "")
	{
		currentVolume = "100";
		System.Gadget.Settings.write("UKRPVolume", 100);
	}


	// check for current station (aS)
	aS = new String(System.Gadget.Settings.read("aS"));
	if (aS == "")
	{
		System.Gadget.Settings.write("aS", 3);
		aS = "3";
	}
	else
	{
		if (parseInt(aS) > theStream.length)
		{
			aS = "3";
			System.Gadget.Settings.write("aS", 3);
		}
//		// work out the new index, just in case - make sure i use aSname!!
//		aSTest = parseInt(upgradePresets(theName[parseInt(aS)]));
//		if (aSTest != -1)
//		{
//			aS = aSTest;
//		}
	}

	// set the correct URL and display the selected station name
	mediaPlayer.url  = theStream[parseInt(aS)];
	playbackStation.innerHTML = sanitizeHTML(theName[parseInt(aS)]);

	// start playing if that's what they want
	autoplay = new String(System.Gadget.Settings.read("autoplayPicker"));
	if (autoplay == "true")
	{
		mediaPlayer.controls.play();
	}

}

function SettingsClosed() 
{
	currentTheme = new String(System.Gadget.Settings.read("themePicker"));
	// this should never happen, but left just in case????
	if (currentTheme == "")
	{
		currentTheme = "Common_Presets";
	}

	if (lastTheme != currentTheme)
	{
		updateTheme();
	}
	// theme has been updated, now sync the variables
	lastTheme = currentTheme;

	tidyupCustom();

	// in case they changed the presets
	//presetCheck();
	presetAlt();

	// check for change in the selected station
	aSOld = parseInt(aS);

	aS = new String(System.Gadget.Settings.read("aS"));
	// again, this should never happen, as set to 3 when it first loads, but left just in case
	if (aS == "")
	{
		aS = "3";
	}

	//update station name in case they edited the custom station name
	// but didn't change the selected station
	if ( playbackStation.innerHTML != sanitizeHTML(theName[parseInt(aS)]) )
	{
		updateStation();
	}

	if (parseInt(aS) != aSOld)
	{
		updateStation();
	}


}

function controlImageClick()
{

	// quick and dirty detection of the player's state, in case the logic ever gets screwed up

	if ((playbackStatus.innerHTML == "Stopped") || (playbackStatus.innerHTML == "Ready"))
	{
		isPlaying = 0;
	}
	if ((playbackStatus.innerHTML == "Playing") || (playbackStatus.innerHTML == "Buffering") || (playbackStatus.innerHTML == "Transitioning"))
	{
		isPlaying = 1;
	}

	if (isPlaying)
	{
		isPlaying = 0;
		mediaPlayer.controls.stop();
	}
	else
	{
		isPlaying = 1;
		mediaPlayer.controls.play();
	}
}

function playStateChange(newstate)
{

	switch (newstate){ 
	case 1: // Stopped
		playbackStatus.innerHTML = "Stopped";
		controlImage.src = "Themes/" + currentTheme + "/play.png";
		break;

	case 2: // Paused (we should never see this)
		playbackStatus.innerHTML = "Paused";
		controlImage.src = "Themes/" + currentTheme + "/play.png";
		break;
	
	case 3: // Playing
		playbackStatus.innerHTML = "Playing";
		controlImage.src = "Themes/" + currentTheme + "/stop.png";
		break;

	case 6: // Buffering
		playbackStatus.innerHTML = "Buffering";
		break;

	case 7: // Waiting
		playbackStatus.innerHTML = "Waiting";
		break;

	case 8: // Media Ended
		playbackStatus.innerHTML = "Media Ended";
		controlImage.src = "Themes/" + currentTheme + "/play.png";
		break;

	case 9: // Transitioning
		playbackStatus.innerHTML = "Transitioning";
		controlImage.src = "Themes/" + currentTheme + "/stop.png";
		break;

	case 10: // Ready
		playbackStatus.innerHTML = "Ready";
		controlImage.src = "Themes/" + currentTheme + "/play.png";
		break;
	}
}
function setFlyout()
{
		System.Gadget.Flyout.show = true;
}

function setSettings()
{
		System.Gadget.Settings.show = true;
}


function next()
{

	if (aS < (theStream.length - 1))
	{
		temp = parseInt(aS);
		temp++;
		aS = "" + temp + "";
	}
	else
	{
		aS = "0";
	}
	System.Gadget.Settings.write("aS", aS);
	updateStation();
}

function prev()
{

	if (aS > 0)
	{
		temp = parseInt(aS);
		temp--;
		aS = "" + temp + "";
	}
	else
	{
		aS = "" + (theStream.length - 1) + "";
	}
	System.Gadget.Settings.write("aS", aS);
	updateStation();
}

function updateStation()
{
	// check if it was playing before we change the URL

	if ((playbackStatus.innerHTML == "Stopped") || (playbackStatus.innerHTML == "Ready"))
	{
		isPlaying = 0;
	}
	if ((playbackStatus.innerHTML == "Playing") || (playbackStatus.innerHTML == "Buffering") || (playbackStatus.innerHTML == "Transitioning"))
	{
		isPlaying = 1;
	}

	// station has changed, so change the URL

	playbackStation.innerHTML = sanitizeHTML(theName[parseInt(aS)]);
	mediaPlayer.url = theStream[parseInt(aS)];

	// restart the stream it was playing before
	if (isPlaying)
	{
		mediaPlayer.controls.play();
	}
}

function setVolume(newVolume)
{
	currentVolume = "" + newVolume + ""; // nasty fudge to keep things as a string
	mediaPlayer.settings.volume = currentVolume;
	// I thought I could safely abandon this, but maybe not?
	currentTheme = new String(System.Gadget.Settings.read("themePicker"));
	if (currentTheme == "")
	{
		currentTheme = "Common_Presets";
	}

	intVolume = parseInt(currentVolume);

	// switch graphics
	if (intVolume == 0)
	{
		volume_icon.src = "Themes/" + currentTheme + "/vol_off.png";
	}

	if ((intVolume > 0) && (intVolume < 50))
	{
		volume_icon.src = "Themes/" + currentTheme + "/vol_low.png";
	}

	if ((intVolume >= 50) && (intVolume < 100))
	{
		volume_icon.src = "Themes/" + currentTheme + "/vol_med.png";
	}

	if (intVolume == 100)
	{
		volume_icon.src = "Themes/" + currentTheme + "/vol_max.png";
	}

}

function volumeDown()
{
	intVolume = parseInt(currentVolume);
	if (intVolume > 9)
	{
		intVolume = (intVolume - 10)
		setVolume("" + intVolume);
		currentVolume = "" + intVolume;
	}

}

function volumeUp()
{
	intVolume = parseInt(currentVolume);
	if (intVolume < 91)
	{
		intVolume = (intVolume + 10)
		setVolume("" + intVolume);
		currentVolume = "" + intVolume;
	}
}

function mousewheelVolume()
{
	oldVol=mediaPlayer.settings.volume;
	if (event.wheelDelta >= 120)
	{
		volumeUp();
	}
	else
	{
		if (event.wheelDelta <= -120)
		{
			volumeDown();
		}
	}
}

window.onunload = function()
{
	// save all the settings again, otherwise they get removed when gadget is closed
	// abandon this, in case this is causing the problems when people upgrade
//	System.Gadget.Settings.write("UKRPVolume", currentVolume);
//	System.Gadget.Settings.write("aS", aS);
//	System.Gadget.Settings.write("themePicker", currentTheme);
//	System.Gadget.Settings.write("autoplayPicker", autoplay);
//	System.Gadget.Settings.write("preset1", preset1);
//	System.Gadget.Settings.write("preset2", preset2);
//	System.Gadget.Settings.write("preset3", preset3);
//	System.Gadget.Settings.write("preset4", preset4);
//	System.Gadget.Settings.write("preset5", preset5);
//	System.Gadget.Settings.write("preset6", preset6);
//	System.Gadget.Settings.write("preset1name", theName[parseInt(preset1)]);
//	System.Gadget.Settings.write("preset2name", theName[parseInt(preset2)]);
//	System.Gadget.Settings.write("preset3name", theName[parseInt(preset3)]);
//	System.Gadget.Settings.write("preset4name", theName[parseInt(preset4)]);
//	System.Gadget.Settings.write("preset5name", theName[parseInt(preset5)]);
//	System.Gadget.Settings.write("preset6name", theName[parseInt(preset6)]);
//	System.Gadget.Settings.write("preset1vol", preset1vol);
//	System.Gadget.Settings.write("preset2vol", preset2vol);
//	System.Gadget.Settings.write("preset3vol", preset3vol);
//	System.Gadget.Settings.write("preset4vol", preset4vol);
//	System.Gadget.Settings.write("preset5vol", preset5vol);
//	System.Gadget.Settings.write("preset6vol", preset6vol);
//	System.Gadget.Settings.write("custom1name", c1name);
//	System.Gadget.Settings.write("custom1url", c1url);
//	System.Gadget.Settings.write("custom2name", c2name);
//	System.Gadget.Settings.write("custom2url", c2url);
//	System.Gadget.Settings.write("custom3name", c3name);
//	System.Gadget.Settings.write("custom3url", c3url);
}

function jumpPreset(presetNumber)
{
	// potentially expensive to read the settings each time, rewrite later??
	thePreset = "preset" + presetNumber;
	jumpTo = new String(System.Gadget.Settings.read(thePreset));
	if (jumpTo.length > 0)
	{
		thePresetVol = thePreset + "vol";
		volTest = new String(System.Gadget.Settings.read(thePresetVol));
		if ((parseInt(volTest) >= 0) && (parseInt(volTest) < 101))
		{
			setVolume(parseInt(volTest));
		}
		if (parseInt(aS) != parseInt(jumpTo))
		{
			aS = "" + jumpTo;
			System.Gadget.Settings.write("aS", aS);
			updateStation();
		}
	}
}

function presetAlt()
{
	preset1 = new String(System.Gadget.Settings.read("preset1"));
	preset2 = new String(System.Gadget.Settings.read("preset2"));
	preset3 = new String(System.Gadget.Settings.read("preset3"));
	preset4 = new String(System.Gadget.Settings.read("preset4"));
	preset5 = new String(System.Gadget.Settings.read("preset5"));
	preset6 = new String(System.Gadget.Settings.read("preset6"));

	// this shouldn't be here... but it is :-S
	preset1vol = new String(System.Gadget.Settings.read("preset1vol"));
	preset2vol = new String(System.Gadget.Settings.read("preset2vol"));
	preset3vol = new String(System.Gadget.Settings.read("preset3vol"));
	preset4vol = new String(System.Gadget.Settings.read("preset4vol"));
	preset5vol = new String(System.Gadget.Settings.read("preset5vol"));
	preset6vol = new String(System.Gadget.Settings.read("preset6vol"));

	if (preset1.length > 0)
	{
		playbackPreset1.alt = theName[parseInt(preset1)];
	}
	else
	{
		playbackPreset1.alt = "";
	}

	if (preset2.length > 0)
	{
		playbackPreset2.alt = theName[parseInt(preset2)];
	}
	else
	{
		playbackPreset2.alt = "";
	}

	if (preset3.length > 0)
	{
		playbackPreset3.alt = theName[parseInt(preset3)];
	}
	else
	{
		playbackPreset3.alt = "";
	}

	if (preset4.length > 0)
	{
		playbackPreset4.alt = theName[parseInt(preset4)];
	}
	else
	{
		playbackPreset4.alt = "";
	}

	if (preset5.length > 0)
	{
		playbackPreset5.alt = theName[parseInt(preset5)];
	}
	else
	{
		playbackPreset5.alt = "";
	}

	if (preset6.length > 0)
	{
		playbackPreset6.alt = theName[parseInt(preset6)];
	}
	else
	{
		playbackPreset6.alt = "";
	}

}

function updateTheme()
{

	// change CSS
	currentCSS.href = "Themes/" + currentTheme + "/Radio.css";

	// change images;
	if (isPlaying)
	{
		controlImage.src = "Themes/" + currentTheme + "/stop.png";
	}
	else
	{
		controlImage.src = "Themes/" + currentTheme + "/play.png";
	}

	setVolume(currentVolume); // this should sort out the graphic!

	// ideally we shouldn't have to do this all of these, I could control it all by switching the css file
	background.src = "Themes/" + currentTheme + "/background.png";
	infoButton.src = "Themes/" + currentTheme + "/info.png";
	previousButton.src = "Themes/" + currentTheme + "/prev.png";
	nextButton.src = "Themes/" + currentTheme + "/next.png";
	vol_minus.src = "Themes/" + currentTheme + "/minus.png";
	vol_plus.src = "Themes/" + currentTheme + "/plus.png";
	playbackPreset1.src = "Themes/" + currentTheme + "/preset1.png";
	playbackPreset2.src = "Themes/" + currentTheme + "/preset2.png";
	playbackPreset3.src = "Themes/" + currentTheme + "/preset3.png";
	playbackPreset4.src = "Themes/" + currentTheme + "/preset4.png";
	playbackPreset5.src = "Themes/" + currentTheme + "/preset5.png";
	playbackPreset6.src = "Themes/" + currentTheme + "/preset6.png";
}

function upgradePresets(oldPreset)
{
	// support for dealing with removal of stations?
	// does this still match even if there's only a partial match?!?

	// do an old fashioned loop through the values, comparing against exact names to avoid any problems,
	// redo stationFixer as an array

	stationFixer.value = oldPreset;
	if (stationFixer.value == oldPreset)
	{
		return stationFixer.selectedIndex;
	}
	else
	{
		return -1
	}
}

function tidyupCustom()
{

	// pop the number of stations held in the customStations variable to get back to the default stations
	// during onload, oCS should be set to 0 already;

	var dumpMe;

	for (i = 0; i < oldCustomStations; i++)
	{
		dumpMe = theName.pop();
		dumpMe = theStream.pop();
		dumpMe = theLogo.pop();
		dumpMe = theXML.pop();
		stationFixer.options[stationFixer.length] = null;
	}

	c1name = System.Gadget.Settings.read("custom1name");
	c1url = System.Gadget.Settings.read("custom1url");
	c2name = System.Gadget.Settings.read("custom2name");
	c2url = System.Gadget.Settings.read("custom2url");
	c3name = System.Gadget.Settings.read("custom3name");
	c3url = System.Gadget.Settings.read("custom3url");
	customStations = 0;

	// set cXname and cXurl to blank, so that they're correctly saved on exit
	// but proactively blank them out anyway

	if ((c1name != "") && (c1url != ""))
	{
		addCustomStation(c1name,c1url, theStream.length);
		stationFixer.options[stationFixer.length] = new Option(sanitizeHTML(c1name),c1url);
		customStations++;
	}
	else
	{
		c1name = "";
		c1url = "";
		System.Gadget.Settings.write("custom1name", c1name);
		System.Gadget.Settings.write("custom1url", c1url);
	}

	if ((c2name != "") && (c2url != ""))
	{
		addCustomStation(c2name,c2url, theStream.length);
		stationFixer.options[stationFixer.length] = new Option(sanitizeHTML(c2name),c2url);
		customStations++;
	}
	else
	{
		c2name = "";
		c2url = "";
		System.Gadget.Settings.write("custom2name", c2name);
		System.Gadget.Settings.write("custom2url", c2url);
	}

	if ((c3name != "") && (c3url != ""))
	{
		addCustomStation(c3name,c3url, theStream.length);
		stationFixer.options[stationFixer.length] = new Option(sanitizeHTML(c3name),c3url);
		customStations++;
	}
	else
	{
		c3name = "";
		c3url = "";
		System.Gadget.Settings.write("custom3name", c3name);
		System.Gadget.Settings.write("custom3url", c3url);
	}

	oldCustomStations = customStations;

	// reintroduce the re-ordering code, so 3 fills blank 1 or 2, and 2 fills a blank 1?

}

function presetCheck()
{
	// recalculate the new station number every time we launch the gadget
	// otherwise upgrades will have incorrect preset settings
	// plus people can fiddle with the stations.js file without too much hassle

	p1name = System.Gadget.Settings.read("preset1name");
	p1index = System.Gadget.Settings.read("preset1");
	p2name = System.Gadget.Settings.read("preset2name");
	p2index = System.Gadget.Settings.read("preset2");
	p3name = System.Gadget.Settings.read("preset3name");
	p3index = System.Gadget.Settings.read("preset3");
	p4name = System.Gadget.Settings.read("preset4name");
	p4index = System.Gadget.Settings.read("preset4");
	p5name = System.Gadget.Settings.read("preset5name");
	p5index = System.Gadget.Settings.read("preset5");
	p6name = System.Gadget.Settings.read("preset6name");
	p6index = System.Gadget.Settings.read("preset6");

	// check if preset is greater or equal to the original size of the array - 1
	// if greater, compare the name against the 3 custom names, if no match then ditch preset info

	if ( (p1name != "") )

	{
		if (p1index >= (stationFixer.length - oldCustomStations) )
		{
			// compare the name against all three custom names
			if ( (p1name == c1name) || (p1name == c2name) || (p1name == c3name) )
			{
				

//				presetTest = parseInt(upgradePresets(p1name));
//				// skip check for -1 as we've directly compared and name was okay so presume index okay
//				preset1 = presetTest;
//				System.Gadget.Settings.write("preset1", preset1);
			}
			else
			{
				// blank out the info
				preset1 = "";
				p1name = "";
				System.Gadget.Settings.write("preset1", preset1);
				System.Gadget.Settings.write("preset1name", p1name);
			
			}
		}
		else
		{
			presetTest = parseInt(upgradePresets(p1name));
			if (presetTest != -1)
			{
				preset1 = presetTest;
				System.Gadget.Settings.write("preset1", preset1);
			}
			else
			{
				preset1 = "";
				p1name = "";
				System.Gadget.Settings.write("preset1", preset1);
				System.Gadget.Settings.write("preset1name", p1name);
			}
		}
	}

	if ( (p2name != "") )

	{
		if (p2index >= (stationFixer.length - oldCustomStations) )
		{
			// compare the name against all three custom names
			if ( (p2name == c1name) || (p2name == c2name) || (p2name == c3name) )
			{
				presetTest = parseInt(upgradePresets(p2name));
				preset2 = presetTest;
				System.Gadget.Settings.write("preset2", preset2);
			}
			else
			{
				// blank out the info
				preset2 = "";
				p2name = "";
				System.Gadget.Settings.write("preset2", preset2);
				System.Gadget.Settings.write("preset2name", p2name);
				
			}
		}
		else
		{
			presetTest = parseInt(upgradePresets(p2name));
			if (presetTest != -1)
			{
				preset2 = presetTest;
				System.Gadget.Settings.write("preset2", preset2);
			}
			else
			{
				preset2 = "";
				p2name = "";
				System.Gadget.Settings.write("preset2", preset2);
				System.Gadget.Settings.write("preset2name", p2name);
			}
		}
	}

	if ( (p3name != "") )

	{
		if (p3index >= (stationFixer.length - oldCustomStations) )
		{
			// compare the name against all three custom names
			if ( (p3name == c1name) || (p3name == c2name) || (p3name == c3name) )
			{
				presetTest = parseInt(upgradePresets(p3name));
				preset3 = presetTest;
				System.Gadget.Settings.write("preset3", preset3);
			}
			else
			{
				// blank out the info
				preset3 = "";
				p3name = "";
				System.Gadget.Settings.write("preset3", preset3);
				System.Gadget.Settings.write("preset3name", p3name);
				
			}
		}
		else
		{
			presetTest = parseInt(upgradePresets(p3name));
			if (presetTest != -1)
			{
				preset3 = presetTest;
				System.Gadget.Settings.write("preset3", preset3);
			}
			else
			{
				preset3 = "";
				p3name = "";
				System.Gadget.Settings.write("preset3", preset3);
				System.Gadget.Settings.write("preset3name", p3name);
			}
		}
	}

	if ( (p4name != "") )

	{
		if (p4index >= (stationFixer.length - oldCustomStations) )
		{
			// compare the name against all three custom names
			if ( (p4name == c1name) || (p4name == c2name) || (p4name == c3name) )
			{
				presetTest = parseInt(upgradePresets(p4name));
				preset4 = presetTest;
				System.Gadget.Settings.write("preset4", preset4);
			}
			else
			{
				// blank out the info
				preset4 = "";
				p4name = "";
				System.Gadget.Settings.write("preset4", preset4);
				System.Gadget.Settings.write("preset4name", p4name);
				
			}
		}
		else
		{
			presetTest = parseInt(upgradePresets(p4name));
			if (presetTest != -1)
			{
				preset4 = presetTest;
				System.Gadget.Settings.write("preset4", preset4);
			}
			else
			{
				preset4 = "";
				p4name = "";
				System.Gadget.Settings.write("preset4", preset4);
				System.Gadget.Settings.write("preset4name", p4name);
			}
		}
	}

	if ( (p5name != "") )

	{
		if (p5index >= (stationFixer.length - oldCustomStations) )
		{
			// compare the name against all three custom names
			if ( (p5name == c1name) || (p5name == c2name) || (p5name == c3name) )
			{
				presetTest = parseInt(upgradePresets(p5name));
				preset5 = presetTest;
				System.Gadget.Settings.write("preset5", preset5);
			}
			else
			{
				// blank out the info
				preset5 = "";
				p5name = "";
				System.Gadget.Settings.write("preset5", p5name);
				System.Gadget.Settings.write("preset5name", p5name);
			}
		}
		else
		{
			presetTest = parseInt(upgradePresets(p5name));
			if (presetTest != -1)
			{
				preset5 = presetTest;
				System.Gadget.Settings.write("preset5", preset5);
			}
			else
			{
				preset5 = "";
				p5name = "";
				System.Gadget.Settings.write("preset5", p5name);
				System.Gadget.Settings.write("preset5name", p5name);
			}
		}
	}

	if ( (p6name != "") )

	{
		if (p6index >= (stationFixer.length - oldCustomStations) )
		{
			// compare the name against all three custom names
			if ( (p6name == c1name) || (p6name == c2name) || (p6name == c3name) )
			{
				presetTest = parseInt(upgradePresets(p6name));
				preset6 = presetTest;
				System.Gadget.Settings.write("preset6", preset6);
			}
			else
			{
				// blank out the info
				preset6 = "";
				p6name = "";
				System.Gadget.Settings.write("preset6", preset6);
				System.Gadget.Settings.write("preset6name", p6name);
			}
		}
		else
		{
			presetTest = parseInt(upgradePresets(p6name));
			if (presetTest != -1)
			{
				preset6 = presetTest;
				System.Gadget.Settings.write("preset6", preset6);
			}
			else
			{
				preset6 = "";
				p6name = "";
				System.Gadget.Settings.write("preset6", preset6);
				System.Gadget.Settings.write("preset6name", p6name);
			}
		}
	}






}